@echo off
rem ~ Author: Ruben ARNAUD
rem ~ Date: 09-2006

rem ~ Bad Arguments
if not .%2. == .. goto :usage

rem ~ Default parameters
set DirXnView=C:\Program Files\XnView
set DirAlbum=F:\Album
set DirFTP=C:\Docume~1\Ruben\Bureau\FTP
set NormalMaxW=0
set NormalMaxH=350
set TNPrefix=TN-
set TNMaxW=128
set TNMaxH=128

rem ~ Read parameters
set ParamFile=%~d0%~p0%~n0.Params.txt
for /F "eol=; tokens=1,2* delims==" %%i in (%ParamFile%) do @set %%i=%%j

rem ~ DirName parameter
set DirName=%1
if not defined DirName goto :all_directories

set DirSrc=%DirAlbum%\%DirName%
set DirHigh=%DirFTP%\%DirName%\pwg_high
set DirPict=%DirFTP%\%DirName%
set DirTN=%DirFTP%\%DirName%\thumbnail

echo.
echo *** %DirSrc% ***

echo.
echo Creating HD Pictures
xcopy /F /R /I /D /H /C /Y "%DirSrc%\*.JPG" "%DirHigh%\"
xcopy /F /R /I /D /H /C /Y "%DirSrc%\*.gif" "%DirHigh%\"
xcopy /F /R /I /D /H /C /Y "%DirSrc%\*.TIF" "%DirHigh%\"


rem ~ -o filename       : Output filename
rem ~ Use # to specify position of numeric enumerator
rem ~ Use % to specify source filename
rem ~ Use $ to specify source folder

rem ~ -out format       : Output format name

rem ~ -c value          : Compression number (default : 0
rem ~ -q value          : JPEG/PNG/FPX/WIC quality (default : 100)

rem ~ -opthuff

rem ~ -resize w h      : Scale width-height
rem ~ w h can be percent (ex: -resize 100% 200%)

rem ~ -i                : Interlaced GIF / Progressive JPEG

echo.
echo Convert HD Pictures
"%DirXnView%\nconvert.exe" -q 100 -opthuff -i -out jpeg -rtype linear -ratio -o %DirHigh%\%%.WasTIF.JPG %DirHigh%\*.TIF
del /F %DirHigh%\*.TIF

echo.
echo Creating Normal Pictures
"%DirXnView%\nconvert.exe" -q 100 -opthuff -i -out jpeg -rtype linear -ratio -resize %NormalMaxW% %NormalMaxH% -o %DirPict%\%%.JPG %DirHigh%\*.JPG
"%DirXnView%\nconvert.exe" -q 100 -opthuff -i -out gif -rtype linear -ratio -resize %NormalMaxW% %NormalMaxH% -o %DirPict%\%%.gif %DirHigh%\*.gif

echo.
echo Creating thumbnail Pictures
mkdir %DirTN%
"%DirXnView%\nconvert.exe" -q 100 -opthuff -i -out jpeg -rtype linear -ratio -resize %TNMaxW% %TNMaxH% -o %DirTN%\%TNPrefix%%%.JPG %DirHigh%\*.JPG
"%DirXnView%\nconvert.exe" -q 100 -opthuff -i -out gif -rtype linear -ratio -resize %TNMaxW% %TNMaxH% -o %DirTN%\%TNPrefix%%%.gif %DirHigh%\*.gif
"%DirXnView%\nconvert.exe" -q 100 -opthuff -i -out jpeg -rtype linear -ratio -resize %TNMaxW% %TNMaxH% -o %DirTN%\%TNPrefix%%%.JPG %DirHigh%\*.TIF

echo.
echo Creating index.php
xcopy /F /R /I /D /H /C /Y "%DirAlbum%\index.php" "%DirPict%\"
xcopy /F /R /I /D /H /C /Y "%DirAlbum%\index.php" "%DirTN%\"
xcopy /F /R /I /D /H /C /Y "%DirAlbum%\index.php" "%DirHigh%\"

goto :end

:all_directories
echo.
echo *************************************************************
echo * Apply %~n0 for all directories of %DirAlbum%
echo *************************************************************
echo.
pause
for /f "tokens=*" %%i in ('dir /B /A:D "%DirAlbum%"') do call %0 %%i


goto :end

:usage
echo Error Bad Parameter
echo Usage:
echo   - All directories: %0 
echo   - Selected Directory: %0 ^<Short Directory Name^>

:end
